
;**********************************************************
;* Program kopiujcy blok bajtw od adresu SOURCE_A
;* zakoczonych znakiem '#', na ekran od offsestu 800. 
;* Po kadym przekopiowanym znaku nastepuje 
;* oczekiwanie na przycinicie klawisza.
;**********************************************************

KONIEC EQU 35		;znak '#' - zakoczenie bloku bajtw
DEST   EQU 0B800H	;segment pamici ekranu karty 						;EGA,VGA w trybie tekstowym

;*******************************************************
CODE    SEGMENT
        ASSUME CS:CODE,DS:CODE
        ORG 100H             ; Program typu .COM, CS=DS


START:  MOV  AX,CS            
        MOV  DS,AX           ; DS <- CS

        MOV  SI,0		; Inicjacja indeksu rda
        MOV  DI,800		; Inicjacja indeksu
					; przeznaczenia   (5*160)

        MOV  AX,DEST 		; AX <- Segment pamici ekranu
        MOV  ES,AX 		; Inicjuj pomocniczy rejestr 
					; segmentowy


LOAD:   MOV  AL,SOURCE_A[SI]	; AL <- SOURCE_A[i]
        CMP  AL,KONIEC      	; czy koniec danych ?
        JE   FINITO         	; tak, wic koczymy
        MOV  AH,07H        	; atrybut do starszego 
						; bajtu
        CALL WAIT_KEY       	; Czekaj na klawisz
        MOV  ES:[DI],AX    	; DEST[800 + i] <- AX
        INC  SI            	; SI <- SI + 1
        ADD  DI,2         	; DI <- DI + 2 poniewa 
					; pami ekranu ma 
					; organizacj: modszy 
					; bajt: znak, starszy: 
					; atrybut
        JMP  LOAD          	; skok pod etykiet LOAD

FINITO: MOV AX,4C00H      	; powrt do DOS'a
        INT 21H


;*******************************************************
;* Procedura oczekiwania na przycinicie klawisza
;*******************************************************
WAIT_KEY PROC NEAR
       PUSHF                  ;zachowaj rejestry
       PUSH AX
       MOV AH,00H
       INT 16H
       POP AX
       POPF                   ;odtwrz rejestry
       RET
ENDP
;*******************  Dane  ***********************
SOURCE_A DB 'Studium Podyplomowe. Laboratorium z Assemblera',KONIEC

CODE ENDS
END START
