
;******************************************************************************
;* Program kopujacy blok bajtow od adresu SOURCE_A zakonczonych znakiem '#'
;* na ekran od offsestu 800. Po kazdym przekopiowanym znaku nastepuje oczekiwanie
;* na przycisniecie klawisza.
;* ponadto program modyfikuje zmienna index (inkrementacja zmiennej w
;* petli glownej oraz przepisuje zawarosc tablicy SOURCE_A do tablicy
;* DEST_A w odwrotnej kolejnosc
;******************************************************************************

KONIEC 		EQU 35		;znak '#' - zakonczenie bloku bajtow
DEST   		EQU 0B800H	;segment pamieci ekranu karty EGA,VGA w trybie 						;tekstowym
ASIZE  		EQU 50

;******************************************************************************
CODE SEGMENT
		ASSUME CS:CODE,DS:CODE
		ORG 100H    		; Program typu .COM


START:		MOV  AX,CS            
		MOV  DS,AX            	; DS <- CS

		MOV  SI,0             	; Inicjacja indeksu zrodla
		MOV  DI,830           	; Inicjacja indeksu przeznaczenia
		MOV  AX,DEST
		MOV  ES,AX            	; Inicjuj pomocniczy rejestr segmentowy

		CALL  CLS              	; czysc ekran
		MOV   INDEX,ASIZE

LOAD:		MOV  AL,SOURCE_A[SI]  	; AL <- SOURCE_A[i]
        	CMP  AL,KONIEC        		; czy koniec danych ?
        	JE   FINITO           		; tak, 	wiec konczymy
        	MOV  AH,07H           		; laduj atrybut do starszego bajtu
        	CALL WAIT_KEY         		; Czekaj na klawisz
        	MOV  ES:[DI],AX       		; DEST[800 + i] <- AX
        	MOV  DX,DI            		; zachowaj DI
        	MOV  DI,INDEX         		; di indeksuje teraz tablice DEST_A
        	MOV  DEST_A[DI],AL    		; wyslij do tablicy
        	MOV  DI,DX            		; odtworz DI
        	INC  SI               		; SI <- SI + 1
        	ADD  DI,2             		; DI <- DI + 2 poniewaz pamiec ekranu ma 						; organizacje:
                           		   		; mlodszy bajt - znak, starszy - atrybut
        	DEC  INDEX
        	JMP  LOAD             		; skok pod etykiete LOAD

FINITO: 	MOV AX,4C00H          		; powrot do DOS'a
        	INT 21H
;*****************************************************************************
;* Procedura oczekiwania na przycisniecie klawisza
;*****************************************************************************
WAIT_KEY PROC NEAR
       		PUSHF
       		PUSH AX
       		MOV AH,00H
       		INT 16H
       		POP AX
       		POPF
       		RET
ENDP


;*****************************************************************************
;* Czysczenie ekranu
;*****************************************************************************
CLS PROC NEAR
        	PUSH DI
        	MOV DI,0
        	MOV AX,0720H       ;SPACJA
        	MOV CX,2000
        	CLD
CLS1:		STOSW              ; AX -> [ES:DI]
        	LOOP CLS1
        	POP  DI
        	RET
ENDP


;******************************  Dane  **************************************
SOURCE_A DB 'Studium Podyplomowe. Laboratorium:  Debuggery', KONIEC
DEST_A   DB ASIZE DUP (32)
INDEX    DW 0
CODE ENDS
END START

